<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'item';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// 获取请求
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';
$cat_id = $check->is_number($_REQUEST['cat_id']) ? $_REQUEST['cat_id'] : 0;

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/item/'); // 实例化类文件(文件上传路径，结尾加斜杠)

// 判断是否开启付费后使用
if ($_PARAM['item_paid_use']) {
    $smarty->assign('paid_use', true);
}

// 赋值给模板
$smarty->assign('rec', $rec);
$smarty->assign('cat_id', $cat_id);

/**
 * +----------------------------------------------------------
 * 内容列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['item']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['item_add'],
            'href' => 'item.php?rec=add&cat_id=' . $cat_id 
    ));
    
    // 获取参数
    $keyword = isset($_REQUEST['keyword']) ? trim($_REQUEST['keyword']) : '';
    
    // 筛选条件
    $where = ' WHERE cat_id IN (' . $cat_id . $dou->dou_child_id('item_category', $cat_id) . ')';
    if ($keyword) {
        $where = $where . " AND title LIKE '%$keyword%'";
        $get = '&keyword=' . $keyword;
    }
 
    // 排序
    $sort = $_OPEN['sort'] ? "sort ASC, " : '';
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT id, title, cat_id, price, image, size, sort, add_time FROM " . $dou->table('item') . $where . " ORDER BY " . $sort . "id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $page_url = 'item.php' . ($cat_id ? '?cat_id=' . $cat_id : '');
    $limit = $dou->pager($sql, 15, $page, $page_url, $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $cat_name = $dou->get_one("SELECT cat_name FROM " . $dou->table('item_category') . " WHERE cat_id = '$row[cat_id]'");
        $add_time = date("Y-m-d", $row['add_time']);
        
        $item_list[] = array (
                "id" => $row['id'],
                "cat_id" => $row['cat_id'],
                "cat_name" => $cat_name,
                "title" => $row['title'],
                "price" => $dou->price_format($row['price']),
                "image" => $dou->dou_file($row['image']),
                "size" => $row['size'],
                "sort" => $row['sort'],
                "add_time" => $add_time 
        );
    }
    
    // 赋值给模板
    $smarty->assign('keyword', $keyword);
    $smarty->assign('item_category', $dou->get_category_nolevel('item_category', $cat_id));
    $smarty->assign('item_list', $item_list);
    
    $smarty->display('item.htm');
} 

/**
 * +----------------------------------------------------------
 * 内容添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['item_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['item'],
            'href' => 'item.php' 
    ));
 
    // 格式化自定义参数，并存到数组$item，内容编辑页面中调用内容详情也是用数组$item，
    if ($_DEFINED['item']) {
        $defined = explode(',', $_DEFINED['item']);
        foreach ($defined as $row) {
            $defined_item .= $row . "：\n";
        }
        $item['defined'] = trim($defined_item);
        $item['defined_count'] = count(explode("\n", $item['defined'])) * 2;
    }
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('item_category', $dou->get_category_nolevel('item_category', $cat_id));
    $smarty->assign('item', $item);
    $smarty->assign('item_id', $dou->auto_id('item'));
    $smarty->assign('btn_lang', $dou->btn_lang('item', '', 'title, content, keywords, description'));
    
    $smarty->display('item.htm');
} 

elseif ($rec == 'insert') {
    // 验证标题
    if (empty($_POST['title']))
        $dou->dou_msg($_LANG['item_title'] . $_LANG['is_empty']);
    
    // 验证选择分类
    if (!$_POST['cat_id'])
        $dou->dou_msg($_LANG['item_category'] . $_LANG['is_empty']);
    
    // 文件上传盒子
    $image = $file->box('item', $dou->auto_id('item'), 'image', 'main');
    
    // 数据格式化
    $add_time = time();
    $_POST['defined'] = str_replace("\r\n", ',', $_POST['defined']);
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "INSERT INTO " . $dou->table('item') . " (id, cat_id, title, defined, content, price, original_price, image, file, size ,keywords, description, sort, add_time)" . " VALUES (NULL, '$_POST[cat_id]', '$_POST[title]', '$_POST[defined]', '$_POST[content]', '$_POST[price]', '$_POST[original_price]', '$image', '$_POST[file]', '$_POST[size]', '$_POST[keywords]', '$_POST[description]', '$_POST[sort]', '$add_time')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['item_add'] . ': ' . $_POST['title']);
    $dou->dou_msg($_LANG['item_add_succes'], 'item.php?cat_id=' . $_POST['cat_id']);
} 

/**
 * +----------------------------------------------------------
 * 内容编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['item_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['item'],
            'href' => 'item.php' 
    ));
    
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';// 获取参数
    
    $item = $dou->get_row('item', '*', "id = '$id'");
    
    // 格式化数据
    $item['image'] = $dou->dou_file($item['image']);
 
    // 格式化自定义参数
    if ($_DEFINED['item'] || $item['defined']) {
        $defined = explode(',', $_DEFINED['item']);
        foreach ($defined as $row) {
            $defined_item .= $row . "：\n";
        }
        // 如果内容中已经写入自定义参数则调用已有的
        $item['defined'] = $item['defined'] ? str_replace(",", "\n", $item['defined']) : trim($defined_item);
        $item['defined_count'] = count(explode("\n", $item['defined'])) * 2;
    }
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('item_category', $dou->get_category_nolevel('item_category', $cat_id));
    $smarty->assign('item_id', $id);
    $smarty->assign('item_content', $item['content']);
    $smarty->assign('item', $item);
    $smarty->assign('btn_lang', $dou->btn_lang('item', $id, 'title, content, keywords, description'));
    
    $smarty->display('item.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
    
    // 验证标题
    if (empty($_POST['title']))
        $dou->dou_msg($_LANG['item_title'] . $_LANG['is_empty']);
    
    // 验证选择分类
    if (!$_POST['cat_id'])
        $dou->dou_msg($_LANG['item_category'] . $_LANG['is_empty']);
        
    // 文件上传盒子
    $image = $file->box('item', $id, 'image', 'main');
    $image = $image ? ", image = '" . $image . "'" : '';
    
    // 格式化自定义参数
    $_POST['defined'] = str_replace("\r\n", ',', $_POST['defined']);
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "UPDATE " . $dou->table('item') . " SET cat_id = '$_POST[cat_id]', title = '$_POST[title]', defined = '$_POST[defined]', content = '$_POST[content]', price = '$_POST[price]', original_price = '$_POST[original_price]'" . $image . ", file = '$_POST[file]', size = '$_POST[size]', keywords = '$_POST[keywords]', description = '$_POST[description]', sort = '$_POST[sort]' WHERE id = '$id'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['item_edit'] . ': ' . $_POST['title']);
    $dou->dou_msg($_LANG['item_edit_succes'], 'item.php?cat_id=' . $_POST['cat_id']);
} 

/**
 * +----------------------------------------------------------
 * 内容删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'item.php');
    $title = $dou->get_one("SELECT title FROM " . $dou->table('item') . " WHERE id = '$id'");
    
    if (isset($_POST['confirm'])) {
        // 删除相应商品图片
        $image = $dou->get_one("SELECT image FROM " . $dou->table('item') . " WHERE id = '$id'");
        $dou->del_file($image);
     
        // 删除对应语言项
        if ($_OPEN['language'])
            $dou->del_lang_value('item', $id);
        
        $dou->create_admin_log($_LANG['item_del'] . ': ' . $title);
        $dou->delete('item', "id = $id", 'item.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $title, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'item.php', '', '30', "item.php?rec=del&id=$id");
    }
} 

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'del_all') {
            // 批量内容删除
            $dou->del_all('item', $_POST['checkbox'], 'id', 'image');
        } elseif ($_POST['action'] == 'category_move') {
            // 批量移动分类
            $dou->category_move('item', $_POST['checkbox'], $_POST['new_cat_id']);
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        $dou->dou_msg($_LANG['item_select_empty']);
    }
} 

/**
 * +----------------------------------------------------------
 * 参数设置
 * +----------------------------------------------------------
 */
elseif ($rec == 'set') {
    $set_list = array('item_paid_use');
    foreach ($set_list as $name) {
        if (!$dou->value_exist('parameter', 'name', $name)) {
            $dou->query("INSERT INTO " . $dou->table('parameter') . " (id, name, lang, value, cue, `group`)" . " VALUES (NULL, '$name', '" . $_LANG['item_' . $name . '_lang'] . "', '" . $_LANG['item_' . $name . '_value'] . "', '" . $_LANG['item_' . $name . '_cue'] . "', 'item')");
        }
    }
    $dou->dou_header('parameter.php?rec=set&group=item');
}

?>