<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'item_category';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/item/icon/'); // 实例化类文件(文件上传路径，结尾加斜杠)

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 分类列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['item_category']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['item_category_add'],
            'href' => 'item_category.php?rec=add' 
    ));
    
    // 赋值给模板
    $smarty->assign('item_category', $dou->get_category_nolevel('item_category'));
    
    $smarty->display('item_category.htm');
} 

/**
 * +----------------------------------------------------------
 * 分类添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['item_category_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['item_category'],
            'href' => 'item_category.php' 
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('item_category', $dou->get_category_nolevel('item_category'));
    $smarty->assign('btn_lang', $dou->btn_lang('item_category', '', 'cat_name, keywords, description'));
    
    $smarty->display('item_category.htm');
} 

elseif ($rec == 'insert') {
    if (empty($_POST['cat_name']))
        $dou->dou_msg($_LANG['item_category_cat_name'] . $_LANG['is_empty']);
    
    if (!$check->is_unique_id($_POST['unique_id'])) {
        $dou->dou_msg($_LANG['unique_id_wrong']);
    } elseif (in_array($_POST['unique_id'], $_MODULE['column'])) {
        $dou->dou_msg($_LANG['item_category_unique_id_wrong']);
    }
        
    if ($dou->value_exist('item_category', 'unique_id', $_POST['unique_id']))
        $dou->dou_msg($_LANG['unique_id_existed']);
        
    // 文件上传盒子
    $auto_id = $dou->auto_id('item_category');
    $icon = $file->box('item_category', $auto_id, 'icon', 'main', 'cat_' . $auto_id);
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "INSERT INTO " . $dou->table('item_category') . " (cat_id, unique_id, cat_name, icon, keywords, description, parent_id, type, sync_to_nav, sort)" . " VALUES (NULL, '$_POST[unique_id]', '$_POST[cat_name]', '$icon', '$_POST[keywords]', '$_POST[description]', '$_POST[parent_id]', '$_POST[type]', '$_POST[sync_to_nav]', '$_POST[sort]')";
    $dou->query($sql);
    
    // 同步自定义导航
    if ($_POST['sync_to_nav'] == '1')
        $dou->update_nav('item_category', $auto_id);
    
    $dou->create_admin_log($_LANG['item_category_add'] . ': ' . $_POST['cat_name']);
    $dou->dou_msg($_LANG['item_category_add_succes'], 'item_category.php');
} 

/**
 * +----------------------------------------------------------
 * 分类编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['item_category_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['item_category'],
            'href' => 'item_category.php' 
    ));
    
    // 获取分类信息
    $cat_id = $check->is_number($_REQUEST['cat_id']) ? $_REQUEST['cat_id'] : '';
    $cat_info = $dou->get_row('item_category', '*', "cat_id = '$cat_id'");
    $cat_info['icon'] = $dou->dou_file($cat_info['icon']);
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('item_category', $dou->get_category_nolevel('item_category', '0', '0', $cat_id));
    $smarty->assign('cat_info', $cat_info);
    $smarty->assign('btn_lang', $dou->btn_lang('item_category', $cat_id, 'cat_name, keywords, description'));
    
    $smarty->display('item_category.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $cat_id = $check->is_number($_POST['cat_id']) ? $_POST['cat_id'] : '';
    
    if (empty($_POST['cat_name']))
        $dou->dou_msg($_LANG['item_category_cat_name'] . $_LANG['is_empty']);
    
    if (!$check->is_unique_id($_POST['unique_id'])) {
        $dou->dou_msg($_LANG['unique_id_wrong']);
    } elseif (in_array($_POST['unique_id'], $_MODULE['column'])) {
        $dou->dou_msg($_LANG['item_category_unique_id_wrong']);
    }

    if ($dou->value_exist('item_category', 'unique_id', $_POST['unique_id'], "cat_id != '$cat_id'"))
        $dou->dou_msg($_LANG['unique_id_existed']);
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    // 文件上传盒子
    $icon = $file->box('product_category', $cat_id, 'icon', 'main', 'cat_' . $cat_id);
    $icon = $icon ? ", icon = '" . $icon . "'" : '';
    
    $sql = "UPDATE " . $dou->table('item_category') . " SET cat_name = '$_POST[cat_name]', unique_id = '$_POST[unique_id]'" . $icon . ", keywords = '$_POST[keywords]', description = '$_POST[description]', parent_id = '$_POST[parent_id]', type = '$_POST[type]', sync_to_nav = '$_POST[sync_to_nav]', sort = '$_POST[sort]' WHERE cat_id = '$cat_id'";
    $dou->query($sql);
 
    // 同步自定义导航
    if ($_POST['sync_to_nav'] == '1')
        $dou->update_nav('item_category', $cat_id);
    
    $dou->create_admin_log($_LANG['item_category_edit'] . ': ' . $_POST['cat_name']);
    $dou->dou_msg($_LANG['item_category_edit_succes'], 'item_category.php');
} 

/**
 * +----------------------------------------------------------
 * 分类删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    $cat_id = $check->is_number($_REQUEST['cat_id']) ? $_REQUEST['cat_id'] : $dou->dou_msg($_LANG['illegal'], 'item_category.php');
    $cat_name = $dou->get_one("SELECT cat_name FROM " . $dou->table('item_category') . " WHERE cat_id = '$cat_id'");
    $is_parent = $dou->get_one("SELECT id FROM " . $dou->table('item') . " WHERE cat_id = '$cat_id'") . $dou->get_one("SELECT cat_id FROM " . $dou->table('item_category') . " WHERE parent_id = '$cat_id'");
    
    if ($is_parent) {
        $_LANG['item_category_del_is_parent'] = preg_replace('/d%/Ums', $cat_name, $_LANG['item_category_del_is_parent']);
        $dou->dou_msg($_LANG['item_category_del_is_parent'], 'item_category.php', '', '3');
    } else {
        if (isset($_POST['confirm'])) {
            // 删除相应图标图片
            $icon = $dou->get_one("SELECT icon FROM " . $dou->table('item_category') . " WHERE cat_id = '$cat_id'");
            $dou->del_file($icon);
         
            // 删除对应语言项
            if ($_OPEN['language'])
                $dou->del_lang_value('item_category', $cat_id);
            
            // 删除自定义导航
            if ($dou->value_exist('nav', 'guide', $cat_id, "module = 'item_category' AND type = 'middle'"))
                $dou->delete('nav', "guide = '$cat_id' AND module = 'item_category' AND type = 'middle'");
            
            $dou->create_admin_log($_LANG['item_category_del'] . ': ' . $cat_name);
            $dou->delete('item_category', "cat_id = $cat_id", 'item_category.php');
        } else {
            $_LANG['del_check'] = preg_replace('/d%/Ums', $cat_name, $_LANG['del_check']);
            $dou->dou_msg($_LANG['del_check'], 'item_category.php', '', '30', "item_category.php?rec=del&cat_id=$cat_id");
        }
    }
}

?>