<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'item';
require (dirname(__FILE__) . '/include/init.php');

// 验证并获取合法的ID，如果不合法将其设定为-1
$id = $firewall->get_legal_id('item', $_REQUEST['id'], $_REQUEST['unique_id']);
$cat_id = $dou->get_one("SELECT cat_id FROM " . $dou->table('item') . " WHERE id = '$id'");
$parent_id = $dou->get_one("SELECT parent_id FROM " . $dou->table('item_category') . " WHERE cat_id = '" . $cat_id . "'");
if ($id == -1) exit;

// 权限验证
$callback = $dou_user->check_login_state(); // 登录验证
if ($callback['msg'] == 'ok') {
    $user_id = $callback['user_id'];
} else {
    if ($_PARAM['item_paid_use']) {
        $data['wrong'] = $_LANG['login_timeout'];
        die(json_encode($data));
    }
}
    
/* 获取产品信息 */
$item = $dou->get_row('item', '*', "id = '$id'");

// 格式化数据
$item['price'] = $dou->price_format($item['price']);
$item['original_price'] = $dou->price_format($item['original_price']);
$item['add_time'] = date("Y-m-d", $item['add_time']);
$item['image'] = $dou->dou_file($item['image']);
$item['file_ext'] = $dou->file_info($item['file'], 'ext');

// 多语言
$item = $dou->lang_box($item, 'item', 'title, content, keywords, description');

// 对应的分类信息
$cate_info = $dou->get_row('item_category', 'cat_id, cat_name', "cat_id = '$item[cat_id]'");
$cate_info['url'] = $dou->rewrite_url('item_category', $item['cat_id']);
$item['cate_info'] = $cate_info;

// 开启付费后使用就要开始判断是否购买或VIP，未开启默认允许访问
if ($_PARAM['item_paid_use']) {
    $access = $dou->access('item', $id, $user_id);
    if (!$access) {
        $item['file'] = '';
     
        // 文本内容分割线
        if (strpos($item['content'], '<hr/>')) {
            $char_count = strlen($item['content']);
            $content = explode('<hr/>', $item['content']);
            $item['content'] = $content[0];
            $item['preview'] = true;
            $item['remaining'] = intval((strlen($content[1]) / $char_count) * 100);
        }
    } else {
        $item['paid_cue'] = $_LANG['item_paid_' . $access];
        $item['content'] = preg_replace('/<hr\/>/U', '', $item['content']);
    }
    
    $data['access'] = $access;
    $data['paid_use'] = true;
} else {
    $data['access'] = false;
    $data['paid_use'] = false;
}

// 访问统计
$click = $item['click'] + 1;
$dou->query("UPDATE " . $dou->table('item') . " SET click = '$click' WHERE id = '$id'");

// 数据封装
$data['defined'] = $defined;
$data['title'] = $_LANG['item_detail'];
$data['item'] = $item;

echo json_encode($data);

?>